
var AWS = require('aws-sdk');
var request = require('request');
var fs = require('fs');
var config = require('./config');

/**
 * Export the following environment variables:
 * 
 * export AWS_BUCKET_NAME='video-bucket'
 * export AWS_REGION='us-east-1'
 * export AWS_ACCESS_KEY_ID='AKID'
 * export AWS_SECRET_ACCESS_KEY='SECRET'
 */

exports.saveVideo = function(sessionToken, videoFileUrl) {

    // copy video to S3 bucket
    var fileExtension = '.mkv'
    var s3Bucket = config.aws.bucket_name;
    var s3Key = sessionToken + fileExtension;

    var body = fs.createReadStream(videoFileUrl);
    var s3obj = new AWS.S3({params: {Bucket: s3Bucket, Key: s3Key}});

    s3obj.upload({Body: body}, function(err, data) {

        if (err) {
            console.log("An error occurred", err);
        } else {
            console.log("Uploaded the file at", data.Location);
            // communicate to portal that the video is ready for processing
            var postUrl = config.portal.protocol + '://' + config.portal.hostname + '/portal/affdex_x2/experiment/set_facevideo_ready';
            console.log(postUrl);
            request.post(
                postUrl,
                { form: { sessionToken: sessionToken } },
                function (error, response, body) {
                    if (!error && response.statusCode == 200) {
                        console.log(body)
                    } else {
                        console.log(error)
                    }
                    // TODO: error handling for portal down.  retry?
                }
            );
        
        }
    });






};